<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;
use Carbon\Carbon;
use App\Http\Base\BaseModel;

class UsersModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "users";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "users";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "username", "id", "kapalId", "roleId", "name", "password", "date_updated", "lokasiId", "aplikasi", "jabatan", "nrp", "aktif"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "username" => "users.username",
        "id" => "users.id",
        "namaKapal" => "kapalId.namaKapal",
        "kapalId" => "users.kapalId",
        "roleName" => "roleId.roleName",
        "name" => "users.name",
        "nrp" => "users.nrp",
        "date_updated" => "users.date_updated",
        "roleId" => "users.roleId"
    ];

    /**
     * relation from ' . kapal . ' by ' . kapalId
     * join kapal on kapal.id = users.kapalId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationKapalId($alias = "kapalId")
    {
        $this->getQuery()->leftjoin("kapal as $alias", "$alias.id", "=", "users.kapalId");
        return $this;
    }

    /**
     * relation from ' . roles . ' by ' . roleId
     * join roles on roles.id = users.roleId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationRoleId($alias = "roleId")
    {
        $this->getQuery()->leftjoin("roles as $alias", "$alias.id", "=", "users.roleId");
        return $this;
    }

    /**
     * relation from ' . activitylog . ' by ' . userId
     * join activitylog on activitylog.id = users.userId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationActivitylogUserId($alias = "activitylog")
    {
        $this->getQuery()->join("activitylog as $alias", "$alias.userId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . loginlog . ' by ' . userId
     * join loginlog on loginlog.id = users.userId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationLoginlogUserId($alias = "loginlog")
    {
        $this->getQuery()->join("loginlog as $alias", "$alias.userId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . notifications . ' by ' . userId
     * join notifications on notifications.id = users.userId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationNotificationsUserId($alias = "notifications")
    {
        $this->getQuery()->join("notifications as $alias", "$alias.userId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . pemakaianstok . ' by ' . userId
     * join pemakaianstok on pemakaianstok.id = users.userId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPemakaianstokUserId($alias = "pemakaianstok")
    {
        $this->getQuery()->join("pemakaianstok as $alias", "$alias.userId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . penerimaanbarang . ' by ' . userId
     * join penerimaanbarang on penerimaanbarang.id = users.userId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPenerimaanbarangUserId($alias = "penerimaanbarang")
    {
        $this->getQuery()->join("penerimaanbarang as $alias", "$alias.userId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . penyesuaianstok . ' by ' . approverId
     * join penyesuaianstok on penyesuaianstok.id = users.approverId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPenyesuaianstokApproverId($alias = "penyesuaianstok")
    {
        $this->getQuery()->join("penyesuaianstok as $alias", "$alias.approverId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . penyesuaianstok . ' by ' . requesterId
     * join penyesuaianstok on penyesuaianstok.id = users.requesterId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPenyesuaianstokRequesterId($alias = "penyesuaianstok")
    {
        $this->getQuery()->join("penyesuaianstok as $alias", "$alias.requesterId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . permintaanbarang . ' by ' . approverId
     * join permintaanbarang on permintaanbarang.id = users.approverId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPermintaanbarangApproverId($alias = "permintaanbarang")
    {
        $this->getQuery()->join("permintaanbarang as $alias", "$alias.approverId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . permintaanbarang . ' by ' . requesterId
     * join permintaanbarang on permintaanbarang.id = users.requesterId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPermintaanbarangRequesterId($alias = "permintaanbarang")
    {
        $this->getQuery()->join("permintaanbarang as $alias", "$alias.requesterId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . pindahstok . ' by ' . approverId
     * join pindahstok on pindahstok.id = users.approverId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPindahstokApproverId($alias = "pindahstok")
    {
        $this->getQuery()->join("pindahstok as $alias", "$alias.approverId", "=", "users.id");
        return $this;
    }

    /**
     * relation from ' . pindahstok . ' by ' . requesterId
     * join pindahstok on pindahstok.id = users.requesterId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPindahstokRequesterId($alias = "pindahstok")
    {
        $this->getQuery()->join("pindahstok as $alias", "$alias.requesterId", "=", "users.id");
        return $this;
    }

    public static function storeFromHO($data)
    {
        $model = (new self())->getQuery()->where("users.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;
            $model->username = $data->username;
            $model->kapalId = $data->kapalId;
            $model->roleId = $data->roleId;
            $model->name = $data->name;
            $model->password = $data->password;
            $model->date_updated = $data->date_updated;
            $model->lokasiId = $data->lokasiId;
            $model->aplikasi = $data->aplikasi;
            $model->jabatan = $data->jabatan;
            $model->nrp = $data->nrp;
            $model->aktif = $data->aktif;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Users - ".$data->id. " - $data->username", Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->id = $data->id;
            $model->username = $data->username;
            $model->kapalId = $data->kapalId;
            $model->roleId = $data->roleId;
            $model->name = $data->name;
            $model->password = $data->password;
            $model->date_updated = $data->date_updated;
            $model->lokasiId = $data->lokasiId;
            $model->aplikasi = $data->aplikasi;
            $model->jabatan = $data->jabatan;
            $model->nrp = $data->nrp;
            $model->aktif = $data->aktif;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Users - ".$data->id. " - $data->username", Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->username . " sync", PHP_EOL;
    }

    public static function getUsers()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_users";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 3)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Users HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {

                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        if($page == 1) {
                            \App\Http\Models\UsersModel::where("aktif", 1)->update(['aktif' => 0]);
                        }
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\UsersModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }

                } catch (Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Users HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Users HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}